package stackjava.com.constructor.demo;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

public class Main {
	public static void main(String[] args) throws InstantiationException, IllegalAccessException, ClassNotFoundException, CloneNotSupportedException, FileNotFoundException, IOException, NoSuchMethodException, SecurityException, IllegalArgumentException, InvocationTargetException {
		Customer c1 = new Customer();
		
		Customer c2 = (Customer)Class.forName("stackjava.com.constructor.demo.Customer").newInstance();
		
		Customer c3 = (Customer) Customer.class.getClassLoader().loadClass("stackjava.com.constructor.demo.Customer").newInstance();

		Customer c4 = Customer.class.newInstance();
		
		Constructor<Customer> constructor = Customer.class.getConstructor();
		Customer c5 = constructor.newInstance();
		
		Customer c6 = (Customer) c1.clone();
		
	     // Serialization
        ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream("customer.dat"));
        out.writeObject(c4);
        out.close();

        // Deserialization
		ObjectInputStream in = new ObjectInputStream(new FileInputStream("customer.dat"));
		Customer c7 = (Customer) in.readObject();

	}

}
